Title:	peg-multimarkdown User's Guide  
Author:	Fletcher T. Penney  
Base Header Level:	2  

# Introduction #

**Sun Dec 20 11:06:45 PST 2015**

## Marked2 reproducible crash

### steps to reproduce

- open the debug version of Marked2 on this file, like this:

~~~bash
jeff at vega in ~/tmp
$ open ./Marked\ 2.app/
~~~

- in this section, add a line of text, and save
- then delete a line of text, and save
- then insert a √ character at the beginning of a line, and save
- then delete the √ character.
- in my experience, after 3-5 of these kinds of user gestures, Marked2 will crash
- I have included a few crash files for you.

- attempt #2 with Marked2 with a try/catch block
- √ √ insert a line, save 
- it seems like it crashes on the third save every time.

- attempt #3 with a 50% smaller file.
- √ insert some stuff

[Markdown] is a simple markup language used to convert plain text into HTML. 

[MultiMarkdown] is a derivative of Markdown that adds new syntax features, such as footnotes, tables, and metadata. Additionally, it offers mechanisms to convert plain text into LaTeX in addition to HTML. 

[peg-multimarkdown] is an implementation of MultiMarkdown derived from John MacFarlane's [peg-markdown]. It makes use of a parsing expression grammar (PEG), and is written in C. It should compile for most any (major) operating system. 

Thanks to work by Daniel Jalkut, MMD no longer requires GLib2 as a dependency. This should make it easier to compile on various operating systems. 


# Installation #


## Mac OS X ##

On the Mac, you can choose from using an installer to install the program for you, or you can compile it yourself from scratch. If you know what that means, follow the instructions below in the Linux section. Otherwise, definitely go for the installer! 

You can also install MultiMarkdown with the package manager [MacPorts] with the following command: 

	sudo port install multimarkdown

Or using [homebrew]: 

	brew install multimarkdown

**NOTE**: I don't maintain either of these ports/packages and can't vouch that they are up to date or working properly.   That said, I have started using [homebrew] to install the latest development build on my machine, while using `make` in my working directory while editing:

	brew install multimarkdown --HEAD

If you don't know what any of that means, just [grab the installer][downloads]. 

If you want to compile for yourself, be sure you have the Developer Tools installed, and then follow the directions for [Linux]. 

If you want to make your own installer, you can use the `make mac-installer` command after compiling the `multimarkdown` binary itself. 


## Windows ##

The easiest way to get peg-multimarkdown running on Windows is to download the installer from the [downloads page][downloads]. It is created with the help of BitRock's software. 

If you want to compile this yourself, you do it in the same way that you would install peg-markdown for Windows. The instructions are on the peg-multimarkdown [wiki] (https://github.com/fletcher/peg-multimarkdown/wiki/Building-for-Windows). I was able to compile for Windows fairly easily using Ubuntu linux following those instructions. I have not tried to actually compile on a Windows machine. 

As a shortcut, if running on a linux machine you can use: 

	make windows

This creates the `multimarkdown.exe` binary. You can then install this manually. 

The `make win-installer` command is what I use to package up the BitRock installer into a zipfile. You probably won't need it. 


## Linux ##

You can either download the source from [peg-multimarkdown], or (preferentially) you can use git: 

	git clone git://github.com/fletcher/peg-multimarkdown.git

You can run the `update_submodules.sh` script to update the submodules if you want to run the test commands, download the sample files and the Support directory, or compile the documentation. 

Then, simply run `make` to compile the source. 

You can also run some test commands to verify that everything is working properly. Of note, it is normal to fail one test in the Markdown tests, but the others should pass. You can then install the binary wherever you like. 

	make
	make test
	make mmd-test
	make latex-test
	make compat-test

**NOTE** As of version 3.2, the tests including obfuscated email addresses will also fail due to a change in how random numbers are generated. 

## FreeBSD ##

If you want to compile manually, you should be able to follow the directions for Linux above.  However, apparently MultiMarkdown has been put in the ports tree, so you can also use: 

	cd /usr/ports/textproc/multimarkdown
	make install

(I have not tested this myself, and cannot guarantee that it works properly.  Come to think of it, I don't even know which version of MMD they use.) 


# Usage #

Once installed, you simply do something like the following: 

* `multimarkdown file.txt` --- process text into HTML. 

* `multimarkdown -c file.txt` --- use a compatibility mode that emulates the original Markdown. 

* `multimarkdown -t latex file.txt` --- output the results as LaTeX instead of HTML. This can then be processed into a PDF if you have LaTeX installed. You can further specify the `LaTeX Mode` metadata to customize output for compatibility with `memoir` or `beamer` classes. 

* `multimarkdown -t odf file.txt` --- output the results as an OpenDocument Text Flat XML file. Does require the plugin be installed in your copy of OpenOffice, which is available at the [downloads] page. LibreOffice includes this plugin by default. 

* `multimarkdown -t opml file.txt` --- convert the MMD text file to an MMD OPML file, compatible with OmniOutliner and certain other outlining and mind-mapping programs (including iThoughts and iThoughtsHD). 

* `multimarkdown -h` --- display help and additional options. 

* `multimarkdown -b *.txt` --- `-b` or `--batch` mode can process multiple files at once, converting `file.txt` to `file.html` or `file.tex` as directed. Using this feature, you can convert a directory of MultiMarkdown text files into HTML files, or LaTeX files with a single command without having to specify the output files manually. **CAUTION**: This will overwrite existing files with the `html` or `tex` extension, so use with caution. 

**Note**: Several convenience scripts are available to simplify things: 

	mmd			=> multimarkdown -b
	mmd2tex		=> multimarkdown -b -t latex
	mmd2odf		=> multimarkdown -b -t odf
	mmd2opml	=> multimarkdown -b -t opml
	
	mmd2pdf		=> Unsupported script to try and run latex/xelatex.
				   You can direct questions to the discussion list, but
				   I may or may not respond.  It works for me, so I share
				   it with those who are interested but make no
				   guarantees.


# Why create another version of MultiMarkdown? #

